/* $Header: /home/aggarwal/lsrc/nocol/src/nsmon/RCS/nstest.c,v 1.3 1993/10/30 03:43:07 aggarwal Exp $ */

/* Copyright 1993 JvNCnet, Global Enterprise Services */

/*+ 
 * FUNCTION:
 * 	Small standalone program to test nsmon().
 *
 * AUTHOR:
 *	S. Spencer Sun, spencer@phoenix.princeton.edu
 */

#include <stdio.h>
#include <sys/types.h>
#include <arpa/nameser.h>
#include "nsmon.h"

usage()
{
  fprintf(stderr,
    "Usage: nstest [ -d ] [ -C query class ] [ -T query type ]\n");
  fprintf(stderr, "\t[ -t timeout (secs) ] nameserver [ nameserver ...  ]\n");
  exit(1);
}

main(argc, argv)
  int argc;
  char *argv[];
{
  int class, type, timeout, ch;
  int aaonly = 0, debug = 0;
  extern char *optarg;
  extern int optind;

  class = C_IN; type = T_SOA; timeout = 15;

  while ((ch = getopt(argc, argv, "AC:dT:t:")) != EOF) {
    switch (ch) {
      case 'A':
        aaonly = 1; break;
      case 'C':
        class = atoi(optarg); break;
      case 'd':
        debug++ ; break;
      case 'T':
        type = atoi(optarg); break;
      case 't':
        timeout = atoi(optarg); break;
      default:
        usage(); break;
    }
  }
  argc -= optind;
  if (argc < 1) {
    fprintf(stderr, "nstest: no servers/requests were specified\n");
    usage() ;
    return 1;
  }
  for (argv += optind; argc >=2; argc -=2, argv +=2) {
    printf("Server: %s  Request: %s  return code: %d\n",
	   argv[0], argv[1], 
	   nsmon(argv[0], argv[1], class, type, timeout, aaonly, debug));
  }
  if (argc) 
    fprintf(stderr, "nsmon: last server did not have a request\n");
  return 0;
}
