/*
 * $Header: /home/aggarwal/lsrc/nocol/src/nsmon/RCS/poll_sites.c,v 1.5 1993/10/30 03:41:25 aggarwal Exp $
 *
 * poll_sites.c for Nameserver monitor (nsmon)
 * 	makes one pass over the entire data file
 * 	adapted from poll_sites.c of pingmon 1.15
 *
 *
 * $Log: poll_sites.c,v $
 * Revision 1.5  1993/10/30  03:41:25  aggarwal
 * *** empty log message ***
 *
 * Revision 1.4  1993/10/29  22:03:36  aggarwal
 * Changed L_INCR to SEEK_CUR. Also deleted the wierd  sockad.sin_addr.S_un
 * stuff. Now passed the 'querydata' properly.
 *
 * Revision 1.3  1993/10/02  05:34:49  aggarwal
 * Moved the 'logic' for escalating severity and updating the
 * loglevel, etc. into a libnocol library routine.
 *
 * Revision 1.2  1993/09/18  22:37:16  aggarwal
 * Added logging, etc.
 *
 * Revision 1.1  1992/06/11  05:06:12  aggarwal
 * Initial revision
 *
 */

/* Copyright 1993 JvNCnet, Global Enterprise Services */

/*+ 
 * INCLUDE FILES
 */

#include "nocol.h"			/* common structures */
#include "nsmon.h"			/* program specific defines */

#include <signal.h>
#include <sys/file.h>
#include <arpa/nameser.h>

static int maxseverity = E_CRITICAL ; /* Max severity of events from nsmon */

/* #defines for finish_status */
#define REACHED_EOF 1
#define READ_ERROR 2

poll_sites(fdout)
     int fdout;				/* Descriptors to open files	*/
{
  EVENT v;			    	/* described in nocol.h		*/
  struct tm *ltime ;    
  time_t locclock ;			/* careful: don't use 'long'	*/
  long status;		       		/* site status			*/
  int bufsize;				/* for reading in file */
  int sigpid;				/* PID of program to get signal	*/

  if ( lseek(fdout, (off_t)0, SEEK_SET) == -1) { /* rewind the file	*/
    perror (prognm);
    return (-1);
  }

  /* 
   * until end of the file or erroneous data... one entire pass
   */

  while ( (bufsize = read (fdout, (char *)&v, sizeof(v))) == sizeof(v) ) 
  {
      switch(nsmon(v.site.addr, querydata, QUERYCLASS, QUERYTYPE,
		   QUERYTIMEOUT, QUERY_AA_ONLY, debug)) 
      {
       case ALL_OK: case NOT_AUTHORITATIVE:
	  status = 1; break;			/* '1' for all OK */
       case ERROR: default:
	  status = 0; break;
      } /* switch */

      update_event(&v, status,/* VALUE */ status, maxseverity);

    /* Now rewind to start of present record and write to the file	*/
     
      lseek(fdout,-(off_t)sizeof(v), SEEK_CUR);
      write (fdout, (char *)&v, sizeof(v));
     
  }		/* end of:    while (read..)	*/
    
  /**** Now determine why we broke out of the above loop *****/
    
  if (bufsize == 0)			/* reached end of the file	*/
    return (1);
  else {				/* error in output data file 	*/
    fprintf (stderr, "%s: Insufficient read data in output file", prognm);
    return (-1);
  }
}	/* end of:  poll_sites		*/

